
/**
 * The test class CustomerListTest.
 *
 * @author  Bernd J. Krmer
 * @version 26.12.2003
 */
public class CustomerListTest extends junit.framework.TestCase
{
    CustomerList customerList3;
    Customer anderz;
    Customer bertrich;
    Customer caspar;
    Customer zerbst;

    /**
     * Default constructor for test class CustomerListTest
     */
    public CustomerListTest()
    {
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    protected void setUp()
    {
        customerList3 = new CustomerList(3);
        anderz = new Customer("anderz", 541);
        bertrich = new Customer("bertrich", 123);
        caspar = new Customer("caspar", 599);
        zerbst = new Customer("zerbst", 555);
    }

    /**
     * Tears down the test fixture.
     *
     * Called after every test case method.
     */
    protected void tearDown()
    {
    }

    public void testAddAndCheckCustomerList()
    {
        assertEquals(true,customerList3.tryAddCustomer(anderz));
        assertEquals(true,customerList3.isInList(anderz));
        assertEquals(false,customerList3.isInList(bertrich));
        assertEquals(false,customerList3.isInList(zerbst));
        assertEquals(1,customerList3.numberOfCustomers());
        assertEquals(true,customerList3.tryAddCustomer(bertrich));
        assertEquals(true,customerList3.isInList(anderz));
        assertEquals(true,customerList3.isInList(bertrich));
        assertEquals(false,customerList3.isInList(zerbst));
        assertEquals(2,customerList3.numberOfCustomers());
        customerList3.printList();
        assertEquals(true,customerList3.tryAddCustomer(caspar));
        assertEquals(true,customerList3.isInList(anderz));
        assertEquals(true,customerList3.isInList(bertrich));
        assertEquals(true,customerList3.isInList(caspar));
        assertEquals(false,customerList3.isInList(zerbst));
        assertEquals(3,customerList3.numberOfCustomers());
        customerList3.printList();
        assertEquals(false,customerList3.tryAddCustomer(zerbst));
        assertEquals(true,customerList3.isInList(anderz));
        assertEquals(true,customerList3.isInList(bertrich));
        assertEquals(true,customerList3.isInList(caspar));
        assertEquals(false,customerList3.isInList(zerbst));
        assertEquals(3,customerList3.numberOfCustomers());
        customerList3.printList();
    }

        public void testAddremoveAndCheckCustomerList()
    {
        assertEquals(true,customerList3.tryAddCustomer(anderz));
        assertEquals(true,customerList3.isInList(anderz));
        assertEquals(false,customerList3.isInList(bertrich));
        assertEquals(true,customerList3.tryAddCustomer(bertrich));
        assertEquals(true,customerList3.tryAddCustomer(caspar));
        assertEquals(true,customerList3.isInList(anderz));
        assertEquals(true,customerList3.isInList(bertrich));
        assertEquals(true,customerList3.isInList(caspar));
        assertEquals(false,customerList3.isInList(zerbst));
        assertEquals(3,customerList3.numberOfCustomers());
        customerList3.printList();
        assertEquals(false,customerList3.tryRemoveCustomer(zerbst));
        assertEquals(true,customerList3.tryRemoveCustomer(anderz));
        assertEquals(false,customerList3.isInList(anderz));
        assertEquals(true,customerList3.isInList(bertrich));
        assertEquals(false,customerList3.isInList(zerbst));
        assertEquals(2,customerList3.numberOfCustomers());
        customerList3.printList();
        assertEquals(false,customerList3.tryAddCustomer(bertrich));
        assertEquals(true,customerList3.tryAddCustomer(bertrich));
        assertEquals(false,customerList3.isInList(anderz));
        assertEquals(true,customerList3.isInList(bertrich));
        assertEquals(false,customerList3.isInList(zerbst));
        assertEquals(2,customerList3.numberOfCustomers());
        customerList3.printList();
        assertEquals(false,customerList3.tryAddCustomer(caspar));
        assertEquals(true,customerList3.tryRemoveCustomer(caspar));
        assertEquals(false,customerList3.isInList(caspar));
        assertEquals(1,customerList3.numberOfCustomers());
        assertEquals(true,customerList3.tryRemoveCustomer(bertrich));
        assertEquals(false,customerList3.isInList(anderz));
        assertEquals(false,customerList3.isInList(bertrich));
        assertEquals(false,customerList3.isInList(caspar));
        assertEquals(0,customerList3.numberOfCustomers());
        assertEquals(true,customerList3.tryAddCustomer(bertrich));
        assertEquals(1,customerList3.numberOfCustomers());
        assertEquals(true,customerList3.tryRemoveCustomer(bertrich));
        assertEquals(false,customerList3.tryRemoveCustomer(bertrich));
        assertEquals(true,customerList3.tryAddCustomer(zerbst));
        assertEquals(false,customerList3.isInList(anderz));
        assertEquals(true,customerList3.isInList(zerbst));
        assertEquals(1,customerList3.numberOfCustomers());
        customerList3.printList();
    }
}



